LeetCode 15.三数之和

目录

题目描述

方法一

思路:

代码:


题目描述

给你一个整数数组 nums ,判断是否存在三元组 [nums[i], nums[j], nums[k]] 满足 i != j、i != k 且 j != k ,同时还满足 nums[i] + nums[j] + nums[k] == 0 。请

你返回所有和为 0 且不重复的三元组。

**注意:**答案中不可以包含重复的三元组。

示例 1:

复制代码
输入:nums = [-1,0,1,2,-1,-4]
输出:[[-1,-1,2],[-1,0,1]]
解释:
nums[0] + nums[1] + nums[2] = (-1) + 0 + 1 = 0 。
nums[1] + nums[2] + nums[4] = 0 + 1 + (-1) = 0 。
nums[0] + nums[3] + nums[4] = (-1) + 2 + (-1) = 0 。
不同的三元组是 [-1,0,1] 和 [-1,-1,2] 。
注意,输出的顺序和三元组的顺序并不重要。

示例 2:

复制代码
输入:nums = [0,1,1]
输出:[]
解释:唯一可能的三元组和不为 0 。

示例 3:

复制代码
输入:nums = [0,0,0]
输出:[[0,0,0]]
解释:唯一可能的三元组和为 0 。

提示:

  • 3 <= nums.length <= 3000
  • -105 <= nums[i] <= 105

方法一

思路:

双指针的题。先对数组进行排序,这样数组就有了单调性。最质朴的思路就是三重循环,但是时间复杂度太高 O(N3),所以第三重循环变成一个从数组最右端开始向左移动的指针 。(双指针我的硬骨头我啃啃啃)

首先,左指针指向第一个数的下一位,右指针从最后一位往前找。因为排序过后具有单调性,若当前的三个数和小于0,那右指针也不要继续往前了,只会更小。指针不动了有这些情况:

1.左右指针相遇了

2.找到三树之和为0了

3.三数之和小于0了

因此最后判断一下,是情况2就加入ans答案中。

有一个点需要注意,因为要求不重复的三元组,每个指针移动最初要判断一下是否和上一个元素相同,相同的话就往移动,直至不同。

代码:

java 复制代码
class Solution {
    public List<List<Integer>> threeSum(int[] nums) {
        int n=nums.length;
        Arrays.sort(nums);
        List<List<Integer>> ans=new ArrayList<List<Integer>>();
        // 枚举 a
        for(int first=0;first<n;first++){
            // 需要和上一次枚举的数不相同
            if(first>0&&nums[first]==nums[first-1]) continue;
            // c 对应的指针初始指向数组的最右端            
            int thrid=n-1;
            int target=0-nums[first];
             // 枚举 b
            for(int second=first+1;second<n;second++){
                 // 需要和上一次枚举的数不相同
                if(second>first+1&&nums[second]==nums[second-1]) continue;
                // 需要保证 b 的指针在 c 的指针的左侧
                while(second<thrid&&nums[second]+nums[thrid]>target){
                    thrid--;
                }
                // 如果指针重合,随着 b 后续的增加
                // 就不会有满足 a+b+c=0 并且 b<c 的 c 了,可以退出循环
                if(second==thrid) break;
                if(nums[second]+nums[thrid]==target) {
                    List<Integer> list=new ArrayList<Integer>();
                    list.add(nums[first]);
                    list.add(nums[second]);
                    list.add(nums[thrid]);
                    ans.add(list);
                }
            }
        }
        return ans;
    }
}
相关推荐
怕浪猫4 小时前
GEO 优化到底是什么?AI时代内容创作者必须懂的新技能
算法·面试·github
朝朝辞暮i5 小时前
C++ 第 23 课:class —— 开始真正进入面向对象
开发语言·c++·算法
Evand J5 小时前
【MATLAB例程】三维RRT+APF避障路径规划与到达角(AOA)定位算法|三维路径优化与定位仿真例程
算法·matlab·路径规划·代码·定位·rrt·aoa
leikooo6 小时前
用餐厅和盘子理解栈和堆
java·数据结构·链表·rust
weixin_307779137 小时前
有限产能智能排产与动态重排智能体:从需求解构到技术实现
开发语言·人工智能·算法·架构
Ivanqhz7 小时前
激活函数在 Transformer 中的作用及各种变体简述
java·linux·数据库·人工智能·深度学习
朝朝辞暮i7 小时前
C++ 第 27 课:智能指针 shared_ptr
开发语言·c++·算法
沙漠之主7 小时前
C++编程教学设计资料:从入门到实战的完整课程方案
java·前端·c++
朝朝辞暮i7 小时前
C++ 第 29 课:回调函数 Callback
开发语言·c++·算法
FPGA小徐7 小时前
PA1 基础设施(2)深度解析:NEMU 中 ITRACE、MTRACE、FTRACE、IRINGBUF、ETRACE、DIFFTEST 全解析
java·服务器·网络